﻿#Automated installation steps based on the official manual steps at
#https://github.com/neovim/neovim/wiki/Installing-Neovim#windows

$ErrorActionPreference = 'Stop'; 

$packageName = 'neovim'
$toolsDir    = "$(Split-Path -parent $MyInvocation.MyCommand.Definition)"
$url         = 'https://ci.appveyor.com/api/buildjobs/hsl90vjrrw6bdbrj/artifacts/build/Neovim.zip' 
$url64       = 'https://ci.appveyor.com/api/buildjobs/d87k66yitsruetoa/artifacts/build/Neovim.zip'
$neovimQtUrl = "https://github.com/equalsraf/neovim-qt/releases/download/staging/neovim-qt.zip"
$noIgnore    = ''
$startBatch  = 'neovim.bat'

$neovimPackageArgs = @{
  packageName   = $packageName
  unzipLocation = $toolsDir
  url           = $url
  url64bit      = $url64
  validExitCodes= @(0) 
  softwareName  = 'Neovim*' 
  checksum      = ''
  checksumType  = 'md5' 
  checksum64    = ''
  checksumType64= 'md5' 
}
$neovimQtPackageArgs = @{
  packageName   = $packageName
  unzipLocation = $toolsDir
  url           = $neovimQtUrl
  url64bit      = $neovimQtUrl
  validExitCodes= @(0) 
  softwareName  = 'Neovim*' 
  checksum      = ''
  checksumType  = 'md5' 
  checksum64    = ''
  checksumType64= 'md5' 
}

function MergeApplicationDirectories($neovimDirectory, $neovimQtDirectory) {
  #Get-ChildItem -Path $neovimDirectory\Neovim\bin\* | Move-Item -Destination $neovimQtDirectory -Force
  #Get-ChildItem -Path $neovimDirectory\Neovim\share\nvim\runtime\* | Move-Item -Destination $neovimQtDirectory -Force
  Copy-Item -Path $neovimDirectory\Neovim\bin\* -Destination $neovimQtDirectory -Recurse -Force
  Copy-Item -Path $neovimDirectory\Neovim\share\nvim\runtime\* -Destination $neovimQtDirectory -Recurse -Force

  Remove-Item -Path $neovimDirectory\Neovim -Recurse -Force
  Move-Item -Path $neovimQtDirectory\nvim-qt.exe -Destination $neovimQtDirectory\neovim.exe
}

function IgnoreToolsExecutables() {
  #Get-ChildItem ".\*" -Force -Include *.exe -Exclude $noIgnore | % { 
  Get-ChildItem ".\*" -Force -Include *.exe | % { 
  '' > "$_.ignore" 
  Write-Debug "$_.ignore file created."
  }
}

Get-ChildItem "$toolsDir\*.bat" | %{ Install-BinFile -Name $_.BaseName -Path $_ }

Install-ChocolateyZipPackage @neovimQtPackageArgs
Install-ChocolateyZipPackage @neovimPackageArgs
Write-Debug "Install packages ended."

MergeApplicationDirectories "$toolsDir" "$toolsDir"
Write-Debug "Merge packages ended."

Push-Location "$toolsDir" 
IgnoreToolsExecutables 
Pop-Location

